
/* include the library headers */
#include <lcrzo.h>
#include "lcrzoex.h"

/*-------------------------------------------------------------*/
/* set information about this example */
shared_lcrzoex_infos lcrzoex_000359=
{ /*reference*/     "lcrzoex", 359,
  /*version*/       1, 0,
  /*title*/         "display urls of an HTML file",
  /*french title*/  "affiche les urls d'un fichier HTML",
  /*description*/   "",
  /*french desc.*/  "",
  /*usage*/         "file [displayurltype [displaypositions]]",
  /*french usage*/  "fichier [afficheletypedurl [affichelaposition]]",
  /*usage example*/ "/tmp/page.html 1 1",
  /*fr. usage ex.*/ "/tmp/page.html 1 1",
  /*author*/        "Laurent"
};

/*-------------------------------------------------------------*/
/* function declarations */
int lcrzoex_000359_main(int argc, char *argv[]);

/*-------------------------------------------------------------*/
/* main function : you can rename it to "main", and then this file
   can be compiled alone. */
int lcrzoex_000359_main(int argc, char *argv[])
{ lcrzo_list list;
  lcrzo_string str;
  lcrzo_uint32 type;
  lcrzo_int32 count, i, startpos, endpos;
  lcrzo_bool displayurltype, displaypositions;

  lcrzo_init();
  if ( argc<2 )
  { /* print usage */
    lcrzo_epr(shared_lcrzoex_infos_print(lcrzoex_000359, argv[0]));
    return(LCRZOEX_ERR_MISC_BADTOOLUSAGE);
  }
  lcrzo_epr(shared_http_urllist_init_file(argv[1], &list));
  displayurltype=LCRZO_FALSE;
  if (argc>2) 
  { lcrzo_epr(lcrzo_bool_init_text(argv[2], &displayurltype));
  }
  displaypositions=LCRZO_FALSE;
  if (argc>3) 
  { lcrzo_epr(lcrzo_bool_init_text(argv[3], &displaypositions));
  }

  lcrzo_epr(lcrzo_list_count(&list, &count));
  for ( i=1 ; i<=count ; i++ )
  { lcrzo_epr(shared_http_urllist_valuem_pos(&list, i, &type, &str,
					     NULL, &startpos, &endpos));
    if (displayurltype)
    { if (type==SHARED_HTTP_URLTYPE_AHREF)
        printf("AHREF");
      else if (type==SHARED_HTTP_URLTYPE_IMGSRC)
        printf("IMGSRC");
      else 
	lcrzo_uint32_print("", type, "%d", "");
      if ( displaypositions )
	printf(",");
    }
    if ( displaypositions )
    { lcrzo_int32_print("", startpos, "%d", "-");
      lcrzo_int32_print("", endpos, "%d", "");
    }
    if ( displayurltype || displaypositions )
      printf(": ");
    printf("%s\n", str);
    lcrzo_string_free(str);
  }
  lcrzo_list_close(&list);

  lcrzo_close();
  return(LCRZO_ERR_OK);
}
