#ifndef LCRZOEX_HTTP_INCLUDED
#define LCRZOEX_HTTP_INCLUDED 1

/*-------------------------------------------------------------*/
int shared_http_initm_methurlhttpver(lcrzo_conststring method,
				     lcrzo_conststring url,
				     lcrzo_conststring version,
				     lcrzo_data *pdata,
				     lcrzo_int32 *pdatasize);

int shared_http_appendm_hostport(lcrzo_conststring hostname,
				 lcrzo_uint16 port,
				 lcrzo_int32 datacurrentsize,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);

int shared_http_appendm_ipport(lcrzo_ipl ip,
			       lcrzo_uint16 port,
			       lcrzo_int32 datacurrentsize,
			       lcrzo_data *pdata,
			       lcrzo_int32 *pdatasize);

int shared_http_appendm_authbasiclogpass(lcrzo_conststring login,
					 lcrzo_conststring passwd,
					 lcrzo_int32 datacurrentsize,
					 lcrzo_data *pdata,
					 lcrzo_int32 *pdatasize);
int shared_http_appendm_proxyauthbasiclogpass(lcrzo_conststring login,
					      lcrzo_conststring passwd,
					      lcrzo_int32 datacurrentsize,
					      lcrzo_data *pdata,
					      lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_http_initm_httpvererr(lcrzo_conststring version,
				 lcrzo_int16 errorcode,
				 lcrzo_conststring errorstring,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);
int shared_http_appendm_connection(lcrzo_conststring type,
				   lcrzo_int32 datacurrentsize,
				   lcrzo_data *pdata,
				   lcrzo_int32 *pdatasize);
int shared_http_appendm_contenttype(lcrzo_conststring type,
				    lcrzo_int32 datacurrentsize,
				    lcrzo_data *pdata,
				    lcrzo_int32 *pdatasize);
int shared_http_appendm_wwwauth(lcrzo_conststring realm,
				lcrzo_int32 datacurrentsize,
				lcrzo_data *pdata,
				lcrzo_int32 *pdatasize);
int shared_http_appendm_location(lcrzo_conststring loc,
				 lcrzo_int32 datacurrentsize,
				 lcrzo_data *pdata,
				 lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_http_percenttext_initm_data(lcrzo_constdata data,
				       lcrzo_int32 datasize,
				       lcrzo_string *ptextwithpercent);

int shared_http_data_initm_percenttext(lcrzo_conststring textwithpercent,
				       lcrzo_data *pdata,
				       lcrzo_int32 *pdatasize);

/*-------------------------------------------------------------*/
int shared_http_request_get(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring proxylogin,
			    lcrzo_conststring proxypasswd,
			    lcrzo_conststring sitelogin,
			    lcrzo_conststring sitepasswd);

int shared_http_request_post(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring proxylogin,
			     lcrzo_conststring proxypasswd,
			     lcrzo_conststring sitelogin,
			     lcrzo_conststring sitepasswd,
			     lcrzo_conststring parameters);

int shared_http_request_head(lcrzo_sock *psock,
			     lcrzo_conststring url,
			     lcrzo_conststring hostname,
			     lcrzo_uint16 port,
			     lcrzo_conststring proxylogin,
			     lcrzo_conststring proxypasswd,
			     lcrzo_conststring sitelogin,
			     lcrzo_conststring sitepasswd);

int shared_http_request_put(lcrzo_sock *psock,
			    lcrzo_conststring url,
			    lcrzo_conststring hostname,
			    lcrzo_uint16 port,
			    lcrzo_conststring proxylogin,
			    lcrzo_conststring proxypasswd,
			    lcrzo_conststring sitelogin,
			    lcrzo_conststring sitepasswd,
			    lcrzo_data filedata,
			    lcrzo_int32 filedatasize);

int shared_http_request_delete(lcrzo_sock *psock,
			       lcrzo_conststring url,
			       lcrzo_conststring hostname,
			       lcrzo_uint16 port,
			       lcrzo_conststring proxylogin,
			       lcrzo_conststring proxypasswd,
			       lcrzo_conststring sitelogin,
			       lcrzo_conststring sitepasswd);

/*-------------------------------------------------------------*/
int shared_http_request_readheader(lcrzo_sock *psock,
				   lcrzo_time *pmaxwaitingtime,
				   lcrzo_string *pmethod,
				   lcrzo_string *purl,
				   lcrzo_string *pversion,
				   lcrzo_string *phost,
				   lcrzo_string *puseragent,
				   lcrzo_string *pproxylogin,
				   lcrzo_string *pproxypasswd,
				   lcrzo_string *psitelogin,
				   lcrzo_string *psitepasswd,
				   lcrzo_int32 *pcontentlength,
				   lcrzo_data *pheader,
				   lcrzo_int32 *pheadersize);
int shared_http_response_readheader(lcrzo_sock *psock,
				    lcrzo_int16 *perrornumber,
				    lcrzo_string *perrormsg,
				    lcrzo_string *pservertype,
				    lcrzo_string *pcontenttype,
				    lcrzo_int32 *pcontentlenght,
				    lcrzo_data *pheader,
				    lcrzo_int32 *pheadersize);

int shared_http_response_readbody(lcrzo_sock *psock,
				  lcrzo_time *pmaxwaitingtime,
				  lcrzo_int32 contentlength,
				  lcrzo_data *pbody,
				  lcrzo_int32 *pbodysize);

/*-------------------------------------------------------------*/
int shared_http_set_proxysite_userpass(int argc, 
				       char *argv[],
				       int startat,
				       lcrzo_string *pproxyuser, 
				       lcrzo_string *pproxypasswd, 
				       lcrzo_string *psiteuser,
				       lcrzo_string *psitepasswd);

int shared_http_get_variablevalue(lcrzo_conststring url,
				  lcrzo_conststring variablename,
				  lcrzo_data *pvariablevalue,
				  lcrzo_int32 *pvariablevaluesize);

int shared_http_url_get_parts(lcrzo_conststring url, 
			      lcrzo_string *pproto, 
			      lcrzo_string *plogin,
			      lcrzo_string *ppasswd, 
			      lcrzo_string *pserver, 
			      lcrzo_uint16 *pport,
			      lcrzo_string *pfile);

int shared_http_url_download_file(lcrzo_conststring siteurl, 
				  lcrzo_conststring proxyurl, 
				  lcrzo_conststring localfile);

/*-------------------------------------------------------------*/
#define SHARED_HTTP_URLTYPE_AHREF   1
#define SHARED_HTTP_URLTYPE_IMGSRC  2

int shared_http_urllist_init(lcrzo_list *plist);
int shared_http_urllist_add_pos(lcrzo_list *plist,
				lcrzo_int32 pos,
				lcrzo_uint32 type,
				lcrzo_conststring url,
				lcrzo_conststring urlreplace,
				lcrzo_int32 startpos,
				lcrzo_int32 endpos);
int shared_http_urllist_valuem_pos(lcrzo_list *plist,
				   lcrzo_int32 pos,
				   lcrzo_uint32 *ptype,
				   lcrzo_string *purl,
				   lcrzo_string *purlreplace,
				   lcrzo_int32 *pstartpos,
				   lcrzo_int32 *pendpos);

/*-------------------------------------------------------------*/
int shared_http_urllist_init_file(lcrzo_conststring filename,
				  lcrzo_list *purllist);

/*-------------------------------------------------------------*/
int shared_http_url_clean(lcrzo_conststring url, 
			  lcrzo_string *purl);

#endif
